#include<cstdio>
#include<cassert>
#include<algorithm>

#define MAXD 502

using namespace std;

int d;
int score;
char G[2*MAXD-1][4*MAXD-3]; // grid
int Kr[2*MAXD-1][4*MAXD-3]; // component id row
int Kc[2*MAXD-1][4*MAXD-3]; // component id col
int N[2*MAXD-1][4*MAXD-3]; // score

void dfs(int r, int c, int rr, int rc) {
  if (r < 0 || r >= 2*d-1)
    return;
  if (c < 0 || c >= 4*d-3)
    return;
  if (G[r][c] != 'L' && G[r][c] != 'F')
    return;
  if (Kr[r][c] >= 0)
    return;
  //printf("assign to %d %d value %d %d\n", r, c, rr, rc);
  Kr[r][c] = rr;
  Kc[r][c] = rc;
  dfs(r+1, c-1, rr, rc);
  dfs(r+1, c+1, rr, rc);
  dfs(r-1, c-1, rr, rc);
  dfs(r-1, c+1, rr, rc);
  dfs(r, c+2, rr, rc);
  dfs(r, c-2, rr, rc);
}

void dfs2(int r, int c) {
  if (r < 0 || r >= 2*d-1)
    return;
  if (c < 0 || c >= 4*d-3)
    return;
  if (G[r][c] == 'L' || G[r][c] == 'F') {
    //printf("take score %d from %d %d\n", score, r, c);
    score = max(score, N[Kr[r][c]][Kc[r][c]]);
    return;
  }
  if (G[r][c] != 'W')
    return;
  G[r][c] = ' ';
  dfs2(r+1, c-1);
  dfs2(r+1, c+1);
  dfs2(r-1, c-1);
  dfs2(r-1, c+1);
  dfs2(r, c+2);
  dfs2(r, c-2);
}

int main() {
  int ncases;
  scanf("%d", &ncases);
  for (int ncase = 0; ncase < ncases; ncase++) {
    scanf("%d", &d);
    assert(getchar() == '\n');
    for (int r = 0; r < 2*d-1; r++) {
      for (int c = 0; c < 4*d - 3; c++) {
        G[r][c] = getchar();
      }
      assert(getchar() == '\n');
    }
    for (int r = 0; r < 2*d-1; r++)
      for (int c = 0; c < 4*d - 3; c++)
        Kr[r][c] = Kc[r][c] = -1;
    for (int r = 0; r < 2*d-1; r++)
      for (int c = 0; c < 4*d - 3; c++)
        dfs(r, c, r, c);
    for (int r = 0; r < 2*d-1; r++)
      for (int c = 0; c < 4*d - 3; c++)
        N[r][c] = 0;
    for (int r = 0; r < 2*d-1; r++)
      for (int c = 0; c < 4*d - 3; c++)
        if (G[r][c] == 'F') {
          N[Kr[r][c]][Kc[r][c]]++;
          //printf("increment %d %d to %d from %d %d\n", Kr[r][c], Kc[r][c], N[Kr[r][c]][Kc[r][c]], r, c);
        }
    score = 0;
    dfs2(d-1, 2*d-2);
    printf("%d\n", score);
  }
}
