#include<cstdio>
#include<cassert>
#include<algorithm>
#include<stack>
#include<utility>

#define MAXD 502

using namespace std;

char G[2*MAXD-1][4*MAXD-3]; // grid
int Kr[2*MAXD-1][4*MAXD-3]; // component id row
int Kc[2*MAXD-1][4*MAXD-3]; // component id col
int N[2*MAXD-1][4*MAXD-3]; // score

int main() {
  int ncases;
  scanf("%d", &ncases);
  for (int ncase = 0; ncase < ncases; ncase++) {
    int d;
    int score;
    scanf("%d", &d);
    assert(getchar() == '\n');
    for (int r = 0; r < 2*d-1; r++) {
      for (int c = 0; c < 4*d - 3; c++) {
        G[r][c] = getchar();
      }
      assert(getchar() == '\n');
    }
    for (int r = 0; r < 2*d-1; r++)
      for (int c = 0; c < 4*d - 3; c++)
        Kr[r][c] = Kc[r][c] = -1;
    for (int rr = 0; rr < 2*d-1; rr++)
      for (int cc = 0; cc < 4*d - 3; cc++) {
        stack<pair<int, int> > S;
        S.push(make_pair(rr, cc));
        while (!S.empty()) {
          pair<int, int> p = S.top();
          S.pop();
          int r = p.first;
          int c = p.second;
          if (r < 0 || r >= 2*d-1)
            continue;
          if (c < 0 || c >= 4*d-3)
            continue;
          if (G[r][c] != 'L' && G[r][c] != 'F')
            continue;
          if (Kr[r][c] >= 0)
            continue;
          Kr[r][c] = rr;
          Kc[r][c] = cc;
          S.push(make_pair(r+1, c-1));
          S.push(make_pair(r+1, c+1));
          S.push(make_pair(r-1, c-1));
          S.push(make_pair(r-1, c+1));
          S.push(make_pair(r, c+2));
          S.push(make_pair(r, c-2));
        }
      }
    for (int r = 0; r < 2*d-1; r++)
      for (int c = 0; c < 4*d - 3; c++)
        N[r][c] = 0;
    for (int r = 0; r < 2*d-1; r++)
      for (int c = 0; c < 4*d - 3; c++)
        if (G[r][c] == 'F')
          N[Kr[r][c]][Kc[r][c]]++;
    score = 0;
    stack<pair<int, int> > S;
    S.push(make_pair(d-1, 2*d-2));
    while (!S.empty()) {
      pair<int, int> p = S.top();
      S.pop();
      int r = p.first;
      int c = p.second;
      if (r < 0 || r >= 2*d-1)
        continue;
      if (c < 0 || c >= 4*d-3)
        continue;
      if (G[r][c] == 'L' || G[r][c] == 'F') {
        score = max(score, N[Kr[r][c]][Kc[r][c]]);
        continue;
      }
      if (G[r][c] != 'W')
        continue;
      G[r][c] = ' ';
      S.push(make_pair(r+1, c-1));
      S.push(make_pair(r+1, c+1));
      S.push(make_pair(r-1, c-1));
      S.push(make_pair(r-1, c+1));
      S.push(make_pair(r, c+2));
      S.push(make_pair(r, c-2));
    }
    printf("%d\n", score);
  }
}
