#include <iostream>
#include <vector>

// solution Bertrand


using namespace std;

const vector<pair<int,int>>  moves = {{0,-1},{-1,-1},{-1,0},{0,1},{1,1},{1,0}};


int ncases,d,nisland, maxfood;
vector<vector<char>> territory;
vector<vector<int>> status;
vector<int> foods;


char c;

bool is_inside(int x, int y) {
    bool ans = true;
    ans &= (x>=0);
    ans &= (x<=2*d-2);
    ans &= (y>=0);
    ans &= (y<=2*d-2);
    if (x<d-1) {
        ans &= ((y-x) <= d-1);
    }        
    if (x>d-1) {
        ans &= ((y-x) >= 1-d);
    }
    return ans;
}

void explore_land(int x, int y){
    status[x][y] = nisland;
    for (auto move =  moves.begin(); move != moves.end(); move++){
        int xx = x + move->first;
        int yy = y + move->second;
        if (is_inside(xx,yy) && (status[xx][yy]==-1) ) {
            if (territory[xx][yy]=='L') {
                explore_land(xx,yy);                
            }
            else if (territory[xx][yy]=='F') {
                foods.back()+=1;
                explore_land(xx,yy);                
            }
        }
    }
}


void explore_sea(int x, int y){
    status[x][y]=0;
    for (auto move =  moves.begin(); move != moves.end(); move++){
        int xx = x + move->first;
        int yy = y + move->second;
        if (is_inside(xx,yy) && (status[xx][yy]==-1) ) {
            if (territory[xx][yy]=='W') {
                explore_sea(xx,yy);                
            }
            else if (territory[xx][yy]=='L') {
                nisland++;
                foods.push_back(0);
                explore_land(xx,yy);                
            }
            else if (territory[xx][yy]=='F') {
                nisland++;
                foods.push_back(1);
                explore_land(xx,yy);                
            }
        }
    }
}



int main(){
    scanf("%d", &ncases);
    for(int ncase=0; ncase<ncases; ncase++){
        territory.clear();
        status.clear();
        nisland=0;
        foods.clear();
        scanf("%d",&d);
       
        for (int k=0;k<d;k++){
            territory.push_back(vector<char>());
            status.push_back(vector<int>());
            for (int i=0; i<d+k; i++){
                scanf(" %c",&c);
                territory[k].push_back(c);
                status[k].push_back(-1);
            }
        }
        for (int k=1;k<d;k++){
            territory.push_back(vector<char>());
            status.push_back(vector<int>());
            for (int i=0;i<k;i++){
                territory[d+k-1].push_back('E');
                status[d+k-1].push_back(-1);
            }
            for (int i=0; i<2*d-k-1; i++){
                scanf(" %c",&c);
                territory[d+k-1].push_back(c);            
                status[d+k-1].push_back(-1);            
            }
        }
          
        explore_sea(d-1,d-1);
        
        maxfood = 0;
        for (auto it = foods.begin(); it != foods.end(); it++){
            if (*it >maxfood) {
                maxfood = *it;
            }
        }
        printf("%d\n",maxfood);
    }
    return 0;
}
