#include<cstdio>

#define f(x) ((k1 + alpha*(x)*(x)) % n)

typedef unsigned long long ull;

int main() {
  int ncases;
  scanf("%d", &ncases);
  for (int ncase = 0; ncase < ncases; ncase++) {
    ull n, k1, alpha;
    scanf("%lld%lld%lld", &n, &k1, &alpha);
    // https://en.wikipedia.org/wiki/Cycle_detection#Brent.27s_algorithm
    ull power = 1, lam = 1;
    ull tortoise = k1;
    ull hare = f(k1);
    while (tortoise != hare) {
      if (power == lam) {
        tortoise = hare;
        power *= 2;
        lam = 0;
      }
      hare = f(hare);
      lam++;
    }
    // find mu
    ull mu = 0;
    tortoise = hare = k1;
    for (ull i = 0; i < lam; i++)
      hare = f(hare);
    while (tortoise != hare) {
      tortoise = f(tortoise);
      hare = f(hare);
      mu++;
    }
    printf("%lld\n", lam+mu);

  }
}
