// usage: ./a.out input_file correct_output output_dir < contestants_output
// See specification there:
// http://www.problemarchive.org/wiki/index.php/Output_validator

#include <iostream>
#include <fstream>
#include <vector>
#include "validate.h"

using namespace std;

int main(int argc, char **argv) {
    init_io(argc, argv);
    int ncases;
    judge_in >> ncases;
    int read = 0;
    string ours;
    string theirs;
    while (getline(author_out, theirs)) {
      read++;
      if (read > ncases)
        wrong_answer("Extra output\n");
      getline(judge_ans, ours);
      if (theirs.length() != ours.length())
        wrong_answer("Length mismatch\n");
      // check the permutation
      int pos = 7;
      while (ours[pos]) {
        if (theirs[pos] != ours[pos]) {
          wrong_answer("Bad permutation\n");
        }
        pos++;
      }
      if (theirs[pos])
        wrong_answer("Bad permutation\n");
      // now, check the float
      ours[7] = 0;
      theirs[7] = 0;
      double oursf, theirsf;
      oursf = atof(ours.c_str());
      theirsf = atof(theirs.c_str());
      //printf("%lf %lf\n", oursf, theirsf);
      if(abs(oursf-theirsf) > 0.00002)
        wrong_answer("permutation too far apart\n");
    }
    if (read != ncases)
      wrong_answer("Not enough output\n");
    accept();
}
