#include<cstdio>
#include<vector>
#include<cassert>
#include<algorithm>

using namespace std;

#define EPS 0.00000000001

int M[8][8];
double P[15][8];
vector<int> V;

int main() {
  int ncases;
  scanf("%d", &ncases);
  for (int ncase = 0; ncase < ncases; ncase++) {
    for (int r = 0; r < 8; r++)
      for (int c = 0; c < 8; c++)
        scanf("%d", &(M[r][c]));
    V.clear();
    for (int i = 1; i < 8; i++) {
      V.push_back(i);
    }
    double best = -1;
    vector <int> Vbest;
    do {
      for (int j = 0; j < 8; j++)
        P[7][j] = (j == 0) ? 1.0 : 0.0;
      for (int i = 8; i < 15; i++)
        for (int j = 0; j < 8; j++)
          P[i][j] = (j == (V[i-8])) ? 1.0 : 0.0;
      for (int i = 6; i >= 0; i--) {
        for (int j = 0; j < 8; j++)
          P[i][j] = 0;
        int nl = 2*i+1, nr = 2*i+2;
        for (int l = 0; l < 8; l++)
          for (int r = 0; r < 8; r++) {
            if (l == r)
              continue;
            if (P[nl][l] < EPS || P[nr][r] < EPS)
              continue;
            int d = M[l][r] + M[r][l];
            assert(d > 0);
            double coeff = P[nl][l] * P[nr][r];
            P[i][l] += (1.*M[l][r]/d) * coeff;
            P[i][r] += (1.*M[r][l]/d) * coeff;
          }
        //for (int j = 0; j < 8; j++)
          //printf("proba of team %d node %d is %lf\n", j, i, P[i][j]);
      }
      if (P[0][0] > best+EPS) {
        Vbest = V;
        best = P[0][0];
      }
    } while (next_permutation(V.begin(), V.end()));
    printf("%.5lf 0", best);
    for (unsigned int i = 0; i < 7; i++)
      printf(" %d", Vbest[i]);
    printf("\n");
  }
  return 0;
}
