// solution by Marc Jeanmougin with explicit computation

#include <algorithm>
#include <cstdio>
#include <cstring>

using namespace std;
char myints[8];
char matches[8][8];
char sol[8];

long double m(char i, char j) {
  return ((long double)matches[myints[i]][myints[j]]) /
         (long double)(matches[myints[i]][myints[j]] +
                       matches[myints[j]][myints[i]]);
}

long double solve() {
  return m(0, 1) * (m(0, 2) * m(2, 3) + m(0, 3) * m(3, 2)) *
         (m(0, 4) *
              (m(4, 5) * m(4, 6) * m(6, 7) + m(4, 5) * m(4, 7) * m(7, 6)) +
          m(0, 5) *
              (m(5, 4) * m(5, 6) * m(6, 7) + m(5, 4) * m(5, 7) * m(7, 6)) +
          m(0, 6) *
              (m(4, 5) * m(6, 4) * m(6, 7) + m(5, 4) * m(6, 5) * m(6, 7)) +
          m(0, 7) *
              (m(4, 5) * m(7, 4) * m(7, 6) + m(5, 4) * m(7, 5) * m(7, 6)));
}

int main() {
  int t;
  scanf("%d", &t);
  for (int tt = 0; tt < t; ++tt) {
    for (int i = 0; i < 8; i++)
      for (int j = 0; j < 8; j++)
        scanf("%d", &(matches[i][j]));
    char init[] = {0, 1, 2, 3, 4, 5, 6, 7};
    memcpy(myints, init, 8);
    long double best = -1;
    do {
      long double x = solve();
      if (x > best + 0.00000001) {
        best = x;
        memcpy(sol, myints, 8);
      }
    } while (std::next_permutation(myints + 1, myints + 8));

    printf("%.5Lf", best);
    for (int i = 0; i < 8; i++)
      printf(" %d", sol[i]);
    printf("\n");
  }
  return 0;
}
