// usage: ./a.out input_file correct_output output_dir < contestants_output
// See specification there:
// http://www.problemarchive.org/wiki/index.php/Output_validator

#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include "validate.h"

using namespace std;

int main(int argc, char **argv) {
    init_io(argc, argv);
    int ncases;
    judge_in >> ncases;
    int read = 0;
    string ours;
    string theirs;
    while (getline(author_out, theirs)) {
      read++;
      if (read > ncases)
        wrong_answer("Extra output\n");
      getline(judge_ans, ours);
      if (abs(((long long) theirs.length()) - ((long long) ours.length())) > 2) {
        //printf("lendiff %s %s\n", theirs.c_str(), ours.c_str());
        wrong_answer("Length difference too big\n");
      }
      long oursl, theirsl;
      oursl = atol(ours.c_str());
      theirsl = atol(theirs.c_str());
      if (theirsl % 100)
        wrong_answer("not correctly rounded\n");
      if(abs(((long long) oursl)- ((long long) theirsl)) > 101) {
        //printf("BAD %ld %ld\n", oursl, theirsl);
        wrong_answer("result too far apart\n");
      }
    }
    if (read != ncases)
      wrong_answer("Not enough output\n");
    accept();
}
