#!/usr/bin/env python3

import functools
import random
from contextlib import redirect_stdout


class Outsidebox(Exception):
    pass

class Sea():
    def __init__(self):
        self.nshots=0
        self.grid=[]
        for _ in range(10):
            self.grid.append([0]*10)
    def set(self,i,j):
        if i<0 or i>9 or j<0 or j>9:
            raise Outsidebox
        if self.grid[i][j]==0:
            self.nshots+=1
            self.grid[i][j]=1
    def __str__(self):
        output=repr(self.nshots)
        for i in range(10):
            for j in range(10):
                if self.grid[i][j]==1:
                    output+="\n{:d} {:d}".format(i+1,j+1)
        return output
    def display(self):
        output=""
        for i in range(10):
            for j in range(10):
                output+="{:d}".format(self.grid[i][j])
            output+="\n"
        print(output)
        

def coin1(sea):
    sea.set(0,0)
    sea.set(1,0)
    sea.set(0,1)
    return(sea)
def coin2(sea):
    sea.set(0,9)
    sea.set(0,8)
    sea.set(1,9)
    return(sea)
def coin3(sea):
    sea.set(9,0)
    sea.set(9,1)
    sea.set(8,0)
    return(sea)
def coin4(sea):
    sea.set(9,9)
    sea.set(9,8)
    sea.set(8,9)
    return(sea)

def barrecourte1(sea,i):
    sea.set(i,0)
    sea.set(i+1,0)
    return(sea)
def barrecourte2(sea,i):
    sea.set(i,9)
    sea.set(i+1,9)
    return(sea)
def barrecourte3(sea,i):
    sea.set(0,i)
    sea.set(0,i+1)
    return(sea)
def barrecourte4(sea,i):
    sea.set(9,i)
    sea.set(9,i+1)
    return(sea)

def boat1(sea,i):
    sea.set(i,0)
    sea.set(i+1,0)
    sea.set(i+2,0)
    return(sea)
def boat2(sea,i):
    sea.set(i,9)
    sea.set(i+1,9)
    sea.set(i+2,9)
    return(sea)
def boat3(sea,i):
    sea.set(0,i)
    sea.set(0,i+1)
    sea.set(0,i+2)
    return(sea)
def boat4(sea,i):
    sea.set(9,i)
    sea.set(9,i+1)
    sea.set(9,i+2)
    return(sea)

def croix(sea,i,j):
    sea.set(i,j)
    sea.set(i-1,j)
    sea.set(i+1,j)
    sea.set(i,j-1)
    sea.set(i,j+1)
    return(sea)


with open("../kpp/data/secret/coin.in","w") as output:
    with redirect_stdout(output):
        print("16")
        for i in range(16):
            sea=Sea()
            if i&1:
                sea = coin1(sea)
            if i&2:
                sea = coin2(sea)
            if i&4:
                sea = coin3(sea)
            if i&8:
                sea = coin4(sea)
            print(sea)

with open("../kpp/data/secret/barrecourte.in","w") as output:
    with redirect_stdout(output):
        print("36")
        for i in range(9):
            print(barrecourte1(Sea(),i))
            print(barrecourte2(Sea(),i))
            print(barrecourte3(Sea(),i))
            print(barrecourte4(Sea(),i))

with open("../kpp/data/secret/singleboat.in","w") as output:
    with redirect_stdout(output):
        print("32")
        for i in range(8):
            print(boat1(Sea(),i))
            print(boat2(Sea(),i))
            print(boat3(Sea(),i))
            print(boat4(Sea(),i))

with open("../kpp/data/secret/croix.in","w") as output:
    with redirect_stdout(output):
        print("64")
        for i in range(1,9):
            for j in range(1,9):
                print(croix(Sea(),i,j))


with open("../kpp/data/secret/multicroix.in","w") as output:
    with redirect_stdout(output):
        n=50
        print(str(n))
        for _ in range(n):
            sea=Sea()
            for _ in range(random.randint(2,8)):
                i=random.randint(1,8)
                j=random.randint(1,8)
                sea = croix(sea,i,j)
            print(sea)

